;This file is for including FASMLIB by source
;Just include this file into project... see examples/fasm

macro include_module name, path {
  local ..code_start, ..code_size, ..data_start, ..data_size

  match =1, DISPLAY_MODULE_INFO \{
    display 'Module "'#`name#'": ',13,10
  \}

  ;save starting addresses
  ..code_start:
  idata \{
    ..data_size = $-..data_start
  \}

  ;include file
  include path

  ;save sizes
  ..code_size = $-..code_start
  idata \{
    ..data_start:
  \}

  match =1, DISPLAY_MODULE_INFO \{
    disp 'size of code: ', dec ..code_size, ' (0x', hex ..code_size, ')'
    disp 'size of data: ', dec ..data_size, ' (0x', hex ..data_size, ')'
  \}

  match =1, DISPLAY_FASMLIB_INFO \{
    total_fasmlib_code = total_fasmlib_code + ..code_size
    total_fasmlib_data = total_fasmlib_data + ..data_size
\}

}

match =1, DISPLAY_FASMLIB_INFO {
  total_fasmlib_code = 0
  total_fasmlib_data = 0
  fasmlib_procs = 0
  fasmlib_aliases = 0
}

include '../../src/fasmlib.inc'
include_module err,	'../../src/err.inc'
include_module mem,	'../../src/mem.inc'
include_module fileio,	'../../src/fileio.inc'
include_module conv,	'../../src/conv.inc'
include_module str,	'../../src/str.inc'
include_module process, '../../src/process.inc'
include_module stream,	'../../src/stream.inc'
include_module text,	'../../src/text.inc'
include_module stdstream, '../../src/stdstream.inc'
include_module fstream, '../../src/fstream.inc'
include_module mstream, '../../src/mstream.inc'

match =1, DISPLAY_FASMLIB_INFO {
    display 'FASMLIB:',13,10
    disp 'procedures: ',	   dec fasmlib_procs	  , ' (0x', hex fasmlib_procs, ')'
    disp 'alises: ',		   dec fasmlib_aliases	  , ' (0x', hex fasmlib_aliases, ')'
    disp 'size of FASMLIB code: ', dec total_fasmlib_code , ' (0x', hex total_fasmlib_code, ')'
    disp 'size of FASMLIB data: ', dec total_fasmlib_data , ' (0x', hex total_fasmlib_data, ')'
}

match =1, INCLUDE_TIMEDATE {
  gettimedate
  idata \{
    db "FASMLIB v", FASMLIB_VERSION_STRING, " compiled at ", DATE, 0
  \}
}

purge include_module