;This file contains list of FASMLIB names
;It can be used in Win32 PE format exports, to provide some debugging information
;see 'examples\fasm\win32\symbols'


; standard FASM "export" macro modified to produce exports only for symbols which
; are used
macro symbols dllname,[label,string]
{
  common
    local module,addresses,names,ordinal,count
    count = 0
  forward
    if used label
      count = count+1
    end if
  common
    dd 0,0,0,RVA module,1
    dd count,count,RVA addresses,RVA names,RVA ordinal
    addresses:
  forward
    if used label
      dd RVA label
    end if
  common
    names:
  forward
    if used label
      local name
      dd RVA name
    end if
  common
    ordinal: count = 0
  forward
    if used label
      dw count
      count = count+1
  end if
  common
    module db dllname,0
  forward
    if used label
      name db string,0
    end if
  common
    local x,y,z,str1,str2,v1,v2
    x = count shr 1
    while x > 0
     y = x
     while y < count
      z = y
      while z-x >= 0
       load v1 dword from names+z*4
       str1=($-RVA $)+v1
       load v2 dword from names+(z-x)*4
       str2=($-RVA $)+v2
       while v1 > 0
	load v1 from str1+%-1
	load v2 from str2+%-1
	if v1 <> v2
	 break
	end if
       end while
       if v1<v2
	load v1 dword from names+z*4
	load v2 dword from names+(z-x)*4
	store dword v1 at names+(z-x)*4
	store dword v2 at names+z*4
	load v1 word from ordinal+z*2
	load v2 word from ordinal+(z-x)*2
	store word v1 at ordinal+(z-x)*2
	store word v2 at ordinal+z*2
       else
	break
       end if
       z = z-x
      end while
      y = y+1
     end while
     x = x shr 1
    end while
}

;FASMLIB symbols included automatically
macro symbols [x] {
  common
    symbols x,fasmlib.init,"fasmlib.init",fasmlib.uninit,"fasmlib.uninit",fasmlib.shutdown,"fasmlib.shutdown",err.text,"err.text",process.exit,"process.exit",fileio.open,"fileio.open",fileio.create,"fileio.create",fileio.append,"fileio.append",fileio.seek,"fileio.seek",fileio.tell,"fileio.tell",fileio.size,"fileio.size",fileio.read,"fileio.read",fileio.write,"fileio.write",fileio.close,"fileio.close",mem.init,"mem.init",mem.uninit,"mem.uninit",mem.alloc,"mem.alloc",mem.alloc0,"mem.alloc0",mem.free,"mem.free",mem.realloc,"mem.realloc",mem.realloc0,"mem.realloc0",mem.size,"mem.size",mem.fill,"mem.fill",mem.copy,"mem.copy",mem.cmp,"mem.cmp",mem.find,"mem.find",mem.findb,"mem.findb",str.copy,"str.copy",str.cat,"str.cat",str.catchar,"str.catchar",str.ins,"str.ins",str.inschar,"str.inschar",str.sub,"str.sub",str.lowcase,"str.lowcase",str.upcase,"str.upcase",str.len,"str.len",str.cmp,"str.cmp",str.cmpi,"str.cmpi",str.pos,"str.pos",str.poschar,"str.poschar",stdstream.init,"stdstream.init",stdstream.uninit,"stdstream.uninit",stream.create,"stream.create",stream.write,"stream.write",stream.write.byte,"stream.write.byte",stream.write.word,"stream.write.word",stream.write.dword,"stream.write.dword",stream.read,"stream.read",stream.read.byte,"stream.read.byte",stream.peek,"stream.peek",stream.peek.byte,"stream.peek.byte",stream.skip,"stream.skip",stream.seek,"stream.seek",stream.tell,"stream.tell",stream.close,"stream.close",stdout,"stdout",stdin,"stdin",stderr,"stderr",conv.b_hex,"conv.b_hex",conv.w_hex,"conv.w_hex",conv.d_hex,"conv.d_hex",conv.q_hex,"conv.q_hex",conv.b_dec,"conv.b_dec",conv.w_dec,"conv.w_dec",conv.d_dec,"conv.d_dec",conv.q_dec,"conv.q_dec",conv.ib_hex,"conv.ib_hex",conv.iw_hex,"conv.iw_hex",conv.id_hex,"conv.id_hex",conv.iq_hex,"conv.iq_hex",conv.ib_dec,"conv.ib_dec",conv.iw_dec,"conv.iw_dec",conv.id_dec,"conv.id_dec",conv.iq_dec,"conv.iq_dec",conv.hex_b,"conv.hex_b",conv.hex_w,"conv.hex_w",conv.hex_d,"conv.hex_d",conv.hex_q,"conv.hex_q",conv.hex_ib,"conv.hex_ib",conv.hex_iw,"conv.hex_iw",conv.hex_id,"conv.hex_id",conv.hex_iq,"conv.hex_iq",conv.dec_b,"conv.dec_b",conv.dec_w,"conv.dec_w",conv.dec_d,"conv.dec_d",conv.dec_q,"conv.dec_q",conv.dec_ib,"conv.dec_ib",conv.dec_iw,"conv.dec_iw",conv.dec_id,"conv.dec_id",conv.dec_iq,"conv.dec_iq",extconv.b_hex,"extconv.b_hex",extconv.w_hex,"extconv.w_hex",extconv.d_hex,"extconv.d_hex",extconv.q_hex,"extconv.q_hex",extconv.b_dec,"extconv.b_dec",extconv.w_dec,"extconv.w_dec",extconv.d_dec,"extconv.d_dec",extconv.q_dec,"extconv.q_dec",extconv.ib_hex,"extconv.ib_hex",extconv.iw_hex,"extconv.iw_hex",extconv.id_hex,"extconv.id_hex",extconv.iq_hex,"extconv.iq_hex",extconv.ib_dec,"extconv.ib_dec",extconv.iw_dec,"extconv.iw_dec",extconv.id_dec,"extconv.id_dec",extconv.iq_dec,"extconv.iq_dec",extconv.hex_b,"extconv.hex_b",extconv.hex_w,"extconv.hex_w",extconv.hex_d,"extconv.hex_d",extconv.hex_q,"extconv.hex_q",extconv.hex_ib,"extconv.hex_ib",extconv.hex_iw,"extconv.hex_iw",extconv.hex_id,"extconv.hex_id",extconv.hex_iq,"extconv.hex_iq",extconv.dec_b,"extconv.dec_b",extconv.dec_w,"extconv.dec_w",extconv.dec_d,"extconv.dec_d",extconv.dec_q,"extconv.dec_q",extconv.dec_ib,"extconv.dec_ib",extconv.dec_iw,"extconv.dec_iw",extconv.dec_id,"extconv.dec_id",extconv.dec_iq,"extconv.dec_iq",text.write,"text.write",text.write.char,"text.write.char",text.write.str,"text.write.str",text.write.format,"text.write.format",text.write.hex,"text.write.hex",text.write.b_hex,"text.write.b_hex",text.write.w_hex,"text.write.w_hex",text.write.d_hex,"text.write.d_hex",text.write.q_hex,"text.write.q_hex",text.write.dec,"text.write.dec",text.write.b_dec,"text.write.b_dec",text.write.w_dec,"text.write.w_dec",text.write.d_dec,"text.write.d_dec",text.write.q_dec,"text.write.q_dec",text.write.ihex,"text.write.ihex",text.write.ib_hex,"text.write.ib_hex",text.write.iw_hex,"text.write.iw_hex",text.write.id_hex,"text.write.id_hex",text.write.iq_hex,"text.write.iq_hex",text.write.idec,"text.write.idec",text.write.ib_dec,"text.write.ib_dec",text.write.iw_dec,"text.write.iw_dec",text.write.id_dec,"text.write.id_dec",text.write.iq_dec,"text.write.iq_dec",text.read.char,"text.read.char",text.read.chars,"text.read.chars",text.read.until,"text.read.until",text.read.line,"text.read.line",text.read.hex,"text.read.hex",text.read.hex_b,"text.read.hex_b",text.read.hex_w,"text.read.hex_w",text.read.hex_d,"text.read.hex_d",text.read.hex_q,"text.read.hex_q",text.read.ihex,"text.read.ihex",text.read.hex_ib,"text.read.hex_ib",text.read.hex_iw,"text.read.hex_iw",text.read.hex_id,"text.read.hex_id",text.read.hex_iq,"text.read.hex_iq",text.read.dec,"text.read.dec",text.read.dec_b,"text.read.dec_b",text.read.dec_w,"text.read.dec_w",text.read.dec_d,"text.read.dec_d",text.read.dec_q,"text.read.dec_q",text.read.idec,"text.read.idec",text.read.dec_ib,"text.read.dec_ib",text.read.dec_iw,"text.read.dec_iw",text.read.dec_id,"text.read.dec_id",text.read.dec_iq,"text.read.dec_iq",text.fetch,"text.fetch",text.fetch.str,"text.fetch.str",text.fetch.char,"text.fetch.char",text.skip.chars,"text.skip.chars",text.skip.until,"text.skip.until",text.extwrite.hex,"text.extwrite.hex",text.extwrite.b_hex,"text.extwrite.b_hex",text.extwrite.w_hex,"text.extwrite.w_hex",text.extwrite.d_hex,"text.extwrite.d_hex",text.extwrite.q_hex,"text.extwrite.q_hex",text.extwrite.dec,"text.extwrite.dec",text.extwrite.b_dec,"text.extwrite.b_dec",text.extwrite.w_dec,"text.extwrite.w_dec",text.extwrite.d_dec,"text.extwrite.d_dec",text.extwrite.q_dec,"text.extwrite.q_dec",text.extwrite.ihex,"text.extwrite.ihex",text.extwrite.ib_hex,"text.extwrite.ib_hex",text.extwrite.iw_hex,"text.extwrite.iw_hex",text.extwrite.id_hex,"text.extwrite.id_hex",text.extwrite.iq_hex,"text.extwrite.iq_hex",text.extwrite.idec,"text.extwrite.idec",text.extwrite.ib_dec,"text.extwrite.ib_dec",text.extwrite.iw_dec,"text.extwrite.iw_dec",text.extwrite.id_dec,"text.extwrite.id_dec",text.extwrite.iq_dec,"text.extwrite.iq_dec",text.extread.chars,"text.extread.chars",text.extread.until,"text.extread.until",text.extread.line,"text.extread.line",text.extread.hex,"text.extread.hex",text.extread.hex_b,"text.extread.hex_b",text.extread.hex_w,"text.extread.hex_w",text.extread.hex_d,"text.extread.hex_d",text.extread.hex_q,"text.extread.hex_q",text.extread.ihex,"text.extread.ihex",text.extread.hex_ib,"text.extread.hex_ib",text.extread.hex_iw,"text.extread.hex_iw",text.extread.hex_id,"text.extread.hex_id",text.extread.hex_iq,"text.extread.hex_iq",text.extread.dec,"text.extread.dec",text.extread.dec_b,"text.extread.dec_b",text.extread.dec_w,"text.extread.dec_w",text.extread.dec_d,"text.extread.dec_d",text.extread.dec_q,"text.extread.dec_q",text.extread.idec,"text.extread.idec",text.extread.dec_ib,"text.extread.dec_ib",text.extread.dec_iw,"text.extread.dec_iw",text.extread.dec_id,"text.extread.dec_id",text.extread.dec_iq,"text.extread.dec_iq",text.extskip.chars,"text.extskip.chars",text.extskip.until,"text.extskip.until",stdout.write,"stdout.write",stdout.write.char,"stdout.write.char",stdout.write.str,"stdout.write.str",stdout.write.format,"stdout.write.format",stdout.write.hex,"stdout.write.hex",stdout.write.b_hex,"stdout.write.b_hex",stdout.write.w_hex,"stdout.write.w_hex",stdout.write.d_hex,"stdout.write.d_hex",stdout.write.q_hex,"stdout.write.q_hex",stdout.write.dec,"stdout.write.dec",stdout.write.b_dec,"stdout.write.b_dec",stdout.write.w_dec,"stdout.write.w_dec",stdout.write.d_dec,"stdout.write.d_dec",stdout.write.q_dec,"stdout.write.q_dec",stdout.write.ihex,"stdout.write.ihex",stdout.write.ib_hex,"stdout.write.ib_hex",stdout.write.iw_hex,"stdout.write.iw_hex",stdout.write.id_hex,"stdout.write.id_hex",stdout.write.iq_hex,"stdout.write.iq_hex",stdout.write.idec,"stdout.write.idec",stdout.write.ib_dec,"stdout.write.ib_dec",stdout.write.iw_dec,"stdout.write.iw_dec",stdout.write.id_dec,"stdout.write.id_dec",stdout.write.iq_dec,"stdout.write.iq_dec",stdout.extwrite.hex,"stdout.extwrite.hex",stdout.extwrite.b_hex,"stdout.extwrite.b_hex",stdout.extwrite.w_hex,"stdout.extwrite.w_hex",stdout.extwrite.d_hex,"stdout.extwrite.d_hex",stdout.extwrite.q_hex,"stdout.extwrite.q_hex",stdout.extwrite.dec,"stdout.extwrite.dec",stdout.extwrite.b_dec,"stdout.extwrite.b_dec",stdout.extwrite.w_dec,"stdout.extwrite.w_dec",stdout.extwrite.d_dec,"stdout.extwrite.d_dec",stdout.extwrite.q_dec,"stdout.extwrite.q_dec",stdout.extwrite.ihex,"stdout.extwrite.ihex",stdout.extwrite.ib_hex,"stdout.extwrite.ib_hex",stdout.extwrite.iw_hex,"stdout.extwrite.iw_hex",stdout.extwrite.id_hex,"stdout.extwrite.id_hex",stdout.extwrite.iq_hex,"stdout.extwrite.iq_hex",stdout.extwrite.idec,"stdout.extwrite.idec",stdout.extwrite.ib_dec,"stdout.extwrite.ib_dec",stdout.extwrite.iw_dec,"stdout.extwrite.iw_dec",stdout.extwrite.id_dec,"stdout.extwrite.id_dec",stdout.extwrite.iq_dec,"stdout.extwrite.iq_dec",stderr.write,"stderr.write",stderr.write.char,"stderr.write.char",stderr.write.str,"stderr.write.str",stderr.write.format,"stderr.write.format",stderr.write.hex,"stderr.write.hex",stderr.write.b_hex,"stderr.write.b_hex",stderr.write.w_hex,"stderr.write.w_hex",stderr.write.d_hex,"stderr.write.d_hex",stderr.write.q_hex,"stderr.write.q_hex",stderr.write.dec,"stderr.write.dec",stderr.write.b_dec,"stderr.write.b_dec",stderr.write.w_dec,"stderr.write.w_dec",stderr.write.d_dec,"stderr.write.d_dec",stderr.write.q_dec,"stderr.write.q_dec",stderr.write.ihex,"stderr.write.ihex",stderr.write.ib_hex,"stderr.write.ib_hex",stderr.write.iw_hex,"stderr.write.iw_hex",stderr.write.id_hex,"stderr.write.id_hex",stderr.write.iq_hex,"stderr.write.iq_hex",stderr.write.idec,"stderr.write.idec",stderr.write.ib_dec,"stderr.write.ib_dec",stderr.write.iw_dec,"stderr.write.iw_dec",stderr.write.id_dec,"stderr.write.id_dec",stderr.write.iq_dec,"stderr.write.iq_dec",stderr.extwrite.hex,"stderr.extwrite.hex",stderr.extwrite.b_hex,"stderr.extwrite.b_hex",stderr.extwrite.w_hex,"stderr.extwrite.w_hex",stderr.extwrite.d_hex,"stderr.extwrite.d_hex",stderr.extwrite.q_hex,"stderr.extwrite.q_hex",stderr.extwrite.dec,"stderr.extwrite.dec",stderr.extwrite.b_dec,"stderr.extwrite.b_dec",stderr.extwrite.w_dec,"stderr.extwrite.w_dec",stderr.extwrite.d_dec,"stderr.extwrite.d_dec",stderr.extwrite.q_dec,"stderr.extwrite.q_dec",stderr.extwrite.ihex,"stderr.extwrite.ihex",stderr.extwrite.ib_hex,"stderr.extwrite.ib_hex",stderr.extwrite.iw_hex,"stderr.extwrite.iw_hex",stderr.extwrite.id_hex,"stderr.extwrite.id_hex",stderr.extwrite.iq_hex,"stderr.extwrite.iq_hex",stderr.extwrite.idec,"stderr.extwrite.idec",stderr.extwrite.ib_dec,"stderr.extwrite.ib_dec",stderr.extwrite.iw_dec,"stderr.extwrite.iw_dec",stderr.extwrite.id_dec,"stderr.extwrite.id_dec",stderr.extwrite.iq_dec,"stderr.extwrite.iq_dec",stdin.read.char,"stdin.read.char",stdin.read.line,"stdin.read.line",stdin.read.chars,"stdin.read.chars",stdin.read.until,"stdin.read.until",stdin.read.hex,"stdin.read.hex",stdin.read.hex_b,"stdin.read.hex_b",stdin.read.hex_w,"stdin.read.hex_w",stdin.read.hex_d,"stdin.read.hex_d",stdin.read.hex_q,"stdin.read.hex_q",stdin.read.ihex,"stdin.read.ihex",stdin.read.hex_ib,"stdin.read.hex_ib",stdin.read.hex_iw,"stdin.read.hex_iw",stdin.read.hex_id,"stdin.read.hex_id",stdin.read.hex_iq,"stdin.read.hex_iq",stdin.read.dec,"stdin.read.dec",stdin.read.dec_b,"stdin.read.dec_b",stdin.read.dec_w,"stdin.read.dec_w",stdin.read.dec_d,"stdin.read.dec_d",stdin.read.dec_q,"stdin.read.dec_q",stdin.read.idec,"stdin.read.idec",stdin.read.dec_ib,"stdin.read.dec_ib",stdin.read.dec_iw,"stdin.read.dec_iw",stdin.read.dec_id,"stdin.read.dec_id",stdin.read.dec_iq,"stdin.read.dec_iq",stdin.fetch,"stdin.fetch",stdin.fetch.str,"stdin.fetch.str",stdin.fetch.char,"stdin.fetch.char",stdin.skip.chars,"stdin.skip.chars",stdin.skip.until,"stdin.skip.until",stdin.extread.line,"stdin.extread.line",stdin.extread.chars,"stdin.extread.chars",stdin.extread.until,"stdin.extread.until",stdin.extread.hex,"stdin.extread.hex",stdin.extread.hex_b,"stdin.extread.hex_b",stdin.extread.hex_w,"stdin.extread.hex_w",stdin.extread.hex_d,"stdin.extread.hex_d",stdin.extread.hex_q,"stdin.extread.hex_q",stdin.extread.ihex,"stdin.extread.ihex",stdin.extread.hex_ib,"stdin.extread.hex_ib",stdin.extread.hex_iw,"stdin.extread.hex_iw",stdin.extread.hex_id,"stdin.extread.hex_id",stdin.extread.hex_iq,"stdin.extread.hex_iq",stdin.extread.dec,"stdin.extread.dec",stdin.extread.dec_b,"stdin.extread.dec_b",stdin.extread.dec_w,"stdin.extread.dec_w",stdin.extread.dec_d,"stdin.extread.dec_d",stdin.extread.dec_q,"stdin.extread.dec_q",stdin.extread.idec,"stdin.extread.idec",stdin.extread.dec_ib,"stdin.extread.dec_ib",stdin.extread.dec_iw,"stdin.extread.dec_iw",stdin.extread.dec_id,"stdin.extread.dec_id",stdin.extread.dec_iq,"stdin.extread.dec_iq",stdin.extskip.chars,"stdin.extskip.chars",stdin.extskip.until,"stdin.extskip.until",file.open,"file.open",file.extopen,"file.extopen",file.create,"file.create",file.extcreate,"file.extcreate",file.append,"file.append",file.extappend,"file.extappend",file.open.handle,"file.open.handle",file.extopen.handle,"file.extopen.handle",file.write,"file.write",file.write.byte,"file.write.byte",file.write.word,"file.write.word",file.write.dword,"file.write.dword",file.read,"file.read",file.read.byte,"file.read.byte",file.peek,"file.peek",file.peek.byte,"file.peek.byte",file.seek,"file.seek",file.tell,"file.tell",file.close,"file.close",mstream.create,"mstream.create",mstream.extcreate,"mstream.extcreate",extconv.dec2d_size,"extconv.dec2d_size",extconv.dec2id_size,"extconv.dec2id_size",extconv.hex2d_size,"extconv.hex2d_size",extconv.hex2id_size,"extconv.hex2id_size",conv.hextable,"conv.hextable",mem.initialized,"mem.initialized",mem.heap,"mem.heap",mem.alloc_count,"mem.alloc_count",text.blank_chars,"text.blank_chars",text.eol_chars,"text.eol_chars",text.extread.dec2d_size,"text.extread.dec2d_size",text.extread.dec2id_size,"text.extread.dec2id_size",text.extread.hex2d_size,"text.extread.hex2d_size",text.extread.hex2id_size,"text.extread.hex2id_size",stream._def_read,"stream._def_read",stream._def_peek,"stream._def_peek",stdstream.initialized,"stdstream.initialized",fstream._vtab,"fstream._vtab",fstream._read,"fstream._read",fstream._write,"fstream._write",fstream._peek,"fstream._peek",fstream._seek,"fstream._seek",fstream._tell,"fstream._tell",fstream._close,"fstream._close",fstream._readbuf,"fstream._readbuf",mstream._vtab,"mstream._vtab",mstream._read,"mstream._read",mstream._write,"mstream._write",mstream._peek,"mstream._peek",mstream._seek,"mstream._seek",mstream._skip,"mstream._skip",mstream._tell,"mstream._tell"
}