;===============================================================================
;file.close
;desc: closes file handle
;args: handle - file handle
;ret: CF set on error
;error: ERR_INVALID_HANDLE - wrong handle
;       ERR_UNKNOWN
;===============================================================================
proc fileio.close handle
	push	ebx

	mov	ebx, [handle]
	mov	eax, 6
	int	80h
	cmp	eax, -4096
	ja	.error_close

	clc

.r:	pop	ebx
	ret
.rc:	stc
	jmp	.r

.error_close:
	;catch EBADF
	cmp	eax, -9; EBADF
	jne	@f
	mov	eax, ERR_INVALID_HANDLE
	jmp	.rc
@@:
	;others
	mov	eax, ERR_UNKNOWN
	jmp	.rc
endp