;internal procedure to be used with heap manager's mem.init.
;Don't call this procedure directly.


;; @name mem.free_heap
;; @desc
;;    This is internal procedure of heap manager, that handles
;;    platform-dependent aspect of deallocating entire heap.
;;    Do not call this procedure.
;; @arg heapptr
;;    Pointer to heap, returned by {mem.alloc_heap} or {mem.realloc_heap}.
;; @arg heapsize
;;    Current size of heap. Must be provided by caller.
;; @err ERR_INVALID_POINTER
;;    Heap pointer is invalid
;; @err ERR_UNKNOWN
;;     System returned error that wasn't translated to FASMLIB error.
;;     You can {contact} author about this, and translation can be added.
proc mem.free_heap heapptr, heapsize
	push	ebx ecx

	;call sys_brk(heapptr)
	mov	ebx, [heapptr]	;pointer to block
	mov	eax, 45 	;sys_brk
	int	80h

	;check error
	cmp	eax, -4096
	ja	.error_brk

	clc

.r:	pop	ecx ebx
	ret

.error_brk:

	;catch invalid block pointer
	cmp eax, -22 ;EINVAL
	jne @f
	mov eax, ERR_INVALID_POINTER
	stc
	jmp .r
@@:
	mov eax, ERR_UNKNOWN
	stc
	jmp	.r

endp