;predefined streams:
idata {
  if used stdstream.initialized | INCLUDE_ALL_DATA eq 1
    stdstream.initialized dd 0
  end if
}

;; @name stdstream.init
;; @desc
;;    Initializes three standard streams: {stdin}, {stdout} and {stderr}.
;;    You should call this procedure before using these streams.
;; @ret
;;    CF set on error
;; @note
;;    If standard streams are already initialized, this procedure does nothing.
;; @note
;;    This procedure is called by {fasmlib.init}.
;;    You can use it for lazy initialization of entire library.
proc stdstream.init

	cmp	[stdstream.initialized], 0
	jne	.rnc

	mov	[stdstream.initialized], 1

.rnc:	clc
	ret
endp