;STDERR stream object

;this object is designed to be always usable, even after stdstream.uninit
;it doesn't use any buffering, and is not closed by stdstream.uninit

idata {
  if used stderr | INCLUDE_ALL_DATA eq 1
    stderr._vtab STREAM_VTAB   \
	0,		       \;close
	stderr._write,	       \
	0,		       \;read
	0,		       \;peek
	0,		       \;skip
	0,		       \;seek
	0			;tell

    stderr STREAM\
	stderr._vtab,	       \;virtual table
	0,0,0,		       \;no write buffer
	0,0,0			;no read buffer
  end if
}

;; @name stderr._write
;; @desc
;;    This is a {stream write method} for {stderr} stream on win32 platform.
;; @note This is platform-specific procedure.
proc stderr._write, stream, buffer, size
local written dd ?

	push	ecx edx

	;do nothing if size=0
	cmp	[size], 0
	je	.rnc

	;get STDERR handle
	push	-12 ;STD_ERROR_HANDLE
	call	[GetStdHandle]
	mov	ecx, eax

	;call WriteFile
	push	0			;reserved
	lea	eax,[written]
	push	eax			;number of chars written
	push	[size]
	push	[buffer]
	push	ecx
	call	[WriteFile]
	or	eax,eax
	jz	.error_WriteFile

	;check if all bytes were written
	mov	eax, [written]
	cmp	eax, [size]
	je	@f
	mov	eax, ERR_UNKNOWN
	jmp	.rc
	@@:

	;return no unwritten bytes
	mov	eax, 0

.rnc:	clc
.r:	pop	edx ecx
	ret
.rc:	stc
	ret

.error_WriteFile:
	call	[GetLastError]

	mov	eax, ERR_UNKNOWN
	jmp	.rc
endp