;; @name conv.d_dec
;; @desc
;;    Converts unsigned dword (32bit) value to decimal string.
;;    For more options use {extconv.d_dec}.
;; @arg dest
;;    Pointer to destination string buffer.
;; @arg destlen
;;    Size of destination string buffer.
;;    Size 11 is always enough for this procedure.
;; @arg value
;;    Dword value to convert.
;; @ret
;;    CF=1 on error.
;; @err ERR_BUFFER_FULL
;;    Destination buffer is not big enough, must be at least 11 bytes.
;;    Only first destlen bytes of resulting string were written.
;;    String in destination buffer is NOT zero terminated.
;; @err ERR_ZERO_SIZE
;;    destlen=0.
;; @nodeps
proc conv.d_dec dest, destlen, value
	libcall extconv.d_dec, [dest], [destlen], [value], 0, 0, 0
	ret
endp