;; @name extconv.dec_b
;; @desc
;;    Converts decimal string to unsigned byte (8bit) value.
;;    This is extended version, for simpler version see {conv.dec_b}.
;; @arg string
;;    Pointer to string to convert.
;; @arg buflen
;;    Size of string's buffer.
;;    You can set this to -1 (FFFFFFFFh) if string is quaranteed to be properly zero-terminated.
;; @arg len
;;    Pointer to dword variable, which will on return hold number of converted characters.
;;    Ignored if zero.
;; @ret
;;    CF=1 on error, otherwise
;;    EAX = value (AL zero extended to dword).
;; @err ERR_NOT_DECIMAL
;;    First character of string is not decimal digit.
;; @err ERR_OUT_OF_RANGE
;;    Value is > 255
;; @err ERR_ZERO_SIZE
;;    strlen=0
;; @note This procedure converts digits until it reaches non-digit character,
;;       or until value overflows.
;; @nodeps
proc extconv.dec_b string, buflen, len
	libcall extconv.dec2d_size, [string], [buflen], 255, [len]
	ret
endp