;; @name conv.hex_id
;; @desc
;;    Converts hexadecimal string to signed dword (32bit) value.
;; @arg string
;;    Pointer to string to convert.
;; @arg buflen
;;    Size of string's buffer.
;;    You can set this to -1 (FFFFFFFFh) if string is quaranteed to be properly zero-terminated.
;; @ret
;;    CF=1 on error, otherwise
;;    EAX = value.
;; @err ERR_NOT_HEXADECIMAL
;;    First character of string is not hexadecimal digit.
;; @err ERR_OUT_OF_RANGE
;;    Value is lesser than -80000000 or greater than 7FFFFFFF.
;; @err ERR_ZERO_SIZE
;;    strlen=0
;; @note This procedure converts digits until it reaches non-digit character,
;;       or until value overflows.
;; @note To get number of converted characters, use {extconv.hex_id}.
;; @nodeps
proc conv.hex_id string, buflen
	libcall extconv.hex2id_size, [string], [buflen], 80000000h, 1, 0
	ret
endp
