;; @name conv.ib_dec
;; @desc
;;    Converts signed byte (8bit) value to decimal string.
;;    For more options use {extconv.ib_dec}.
;; @arg dest
;;    Pointer to destination string buffer.
;; @arg destlen
;;    Size of destination string buffer.
;;    Size 5 is always enough for this procedure.
;; @arg value
;;    Byte value to convert.
;;    Only low order byte of this dword is used, rest is ignored.
;; @ret
;;    CF=1 on error.
;; @err ERR_BUFFER_FULL
;;    Destination buffer is not big enough, must be at least 5 bytes.
;;    Only first destlen bytes of resulting string were written.
;;    String in destination buffer is NOT zero terminated.
;; @err ERR_ZERO_SIZE
;;    destlen=0.
;; @nodeps
proc conv.ib_dec dest, destlen, value
	movsx	eax, byte [value]
	libcall extconv.id_dec, [dest], [destlen], eax, 0, 0, 0, 0
	ret
endp