;; @name conv.id_hex
;; @desc
;;    Converts signed dword (32bit) value to decimal string.
;;    For more options use {extconv.id_hex}.
;; @arg dest
;;    Pointer to destination string buffer.
;; @arg destlen
;;    Size of destination string buffer.
;;    Size 10 is always enough for this procedure.
;; @arg value
;;    Dword value to convert.
;; @ret
;;    CF=1 on error.
;; @err ERR_BUFFER_FULL
;;    Destination buffer is not big enough, must be at least 10 bytes.
;;    Only first destlen bytes of resulting string were written.
;;    String in destination buffer is NOT zero terminated.
;; @err ERR_ZERO_SIZE
;;    destlen=0.
;; @nodeps
proc conv.id_hex dest, destlen, value
	libcall extconv.id_hex, [dest], [destlen], [value], 0, 0, 0, 0
	ret
endp