;; @name conv.q_hex
;; @desc
;;    Converts unsigned qword (64bit) value to hexadecimal string.
;;    For more options use {extconv.q_hex}.
;; @arg dest
;;    Pointer to destination string buffer.
;; @arg destlen
;;    Size of destination string buffer.
;;    Size 9 is always enough for this procedure.
;; @arg valuelow
;;    Low order dword of value to convert.
;; @arg valuehigh
;;    High order dword of value to convert.
;; @ret
;;    CF=1 on error.
;; @err ERR_BUFFER_FULL
;;    Destination buffer is not big enough (must be at least 17 bytes).
;;    Only first destlen bytes of resulting string were written.
;;    String in destination buffer is NOT zero terminated.
;; @err ERR_ZERO_SIZE
;;    destlen=0.
;; @nodeps
proc conv.q_hex dest, destlen, valuelow, valuehigh
	libcall extconv.q_hex, [dest], [destlen], [valuelow], [valuehigh], 0, 0, 0
	ret
endp