;; @name conv.w_dec
;; @desc
;;    Converts unsigned word (16bit) value to decimal string.
;;    For more options use {extconv.w_dec}.
;; @arg dest
;;    Pointer to destination string buffer.
;; @arg destlen
;;    Size of destination string buffer.
;;    Size 6 is always enough for this procedure.
;; @arg value
;;    Word value to convert.
;;    Only low order word of this dword is used, rest is ignored.
;; @ret
;;    CF=1 on error.
;; @err ERR_BUFFER_FULL
;;    Destination buffer is not big enough, must be at least 6 bytes.
;;    Only first destlen bytes of resulting string were written.
;;    String in destination buffer is NOT zero terminated.
;; @err ERR_ZERO_SIZE
;;    destlen=0.
;; @nodeps
proc conv.w_dec dest, destlen, value
	movzx	eax, word [value]
	libcall extconv.d_dec, [dest], [destlen], eax, 0, 0, 0
	ret
endp