;FASMLIB
;this file contains internal macros used to display values at compile time

;=================================================
; desc: displays number as decimal value
; args: value - value to display
; note: - this is simpler version designed to work with 32bit values
;         for more advanced version see this:
;         http://board.flatassembler.net/topic.php?p=55377#55377
macro display_dec value* {
    local leading_zero,digit,divisor,number
    number=value

    if number<0
      number=-number
      display '-'
    end if

    leading_zero=0
    divisor=1000000000000000000

    while divisor>0
      digit=number/divisor
      leading_zero=leading_zero+digit
      if leading_zero | (divisor=1)
	display digit+'0'
	number=number-digit*divisor
      end if
      divisor=divisor/10
    end while
}

;==============================================
;display_hex
;desc: debugging macro to display value of unsigned hex dword at assembly time, prepended by text
;args: text  - text to display
;      dword - dword value to display
macro display_hex value*
{
    local leading_zero,digit,divisor,number
    number=value

    if number<0
      number=-number
      display '-'
    end if

    leading_zero=0
    divisor=1000000000000000h

    while divisor>0
      digit=number/divisor
      leading_zero=leading_zero+digit
      if leading_zero | (divisor=1)
	if (digit < 10)
	  display digit+'0'
	else
	  display digit+'A'-10
	end if
	number=number-digit*divisor
      end if
      divisor=divisor/16
    end while
}

;==============================================
;disp
;desc: macro that displays formatted line of text
;args: text  - text to display
;      dword - dword value to display
macro disp [thing*]
{
  forward
    if thing eqtype ''
      display thing
    else
      match =dec value, thing \{
	display_dec value
      \}
      match =hex value, thing \{
	display_hex value
      \}
    end if
  common
    display 13,10
}