;FSTREAM virtual table

idata {
  if used fstream._vtab | INCLUDE_ALL_DATA eq 1
    fstream._vtab STREAM_VTAB\
       fstream._close,	   \ ;close
       fstream._write,	   \ ;write
       fstream._read,	   \ ;read
       fstream._peek,	   \ ;peek
       0,		   \ ;skip method unsupported, see comment at end of file
       fstream._seek,	   \ ;seek
       fstream._tell	     ;tell
  end if
}

; callback for default stream handlers
proc fstream._readbuf, stream, buffer, count
	mov	eax, [stream]
	mov	eax, [eax + FSTREAM.handle]
	libcall fileio.read, eax, [buffer], [count]
	ret
endp




;- why is skip method not provided:
;   writing skip method using fileio.seek would be pretty costly,
;   because we have to check end of file. That is not possible with
;   fileio.seek, so we would have to always get size of file, and
;   check if we didn't seek behind end of file.
;   skip is usually used often, and only for few bytes, so that will
;   take too long.
;   If skip method isn't supported, stream.seek simply uses read method
;   to read data off the stream. That is in our case better solution,
;   as long as someone doesn't skip large amount of bytes.
;   In future, we could implement both ways of skiping (read and seek)
;   into skip method, and decide which to use on number of bytes to skip.