idata {
mem.initialized db 0	;0 = module not initialized, 1=initialized
}

udata {
mem.heap.start	dd ?	;pointer to beginning of heap
mem.heap.size	dd ?	;size of heap
mem.alloc_count dd ?	;number of allocations (to discover memory leak)
mem.heap_corrupt db ?	;0 = okay, 1 = heap corrupt
}


;============================================================================
; mem.init
; desc: initalizes mem module (and it's heap manager)
; args: none
; ret: CF set on error
; note: initialization is required for allocation
; error: ERR_UNKNOWN - platform-specific error
;        +mem.alloc_heap (in platform-dependant part of mem module)
;============================================================================
proc mem.init

	;if module is already initialized, just return
	cmp	[mem.initialized], 0
	jne	.rnc

	; call platform-dependant heap allocation
	libcall mem.alloc_heap, HEAP_INIT_SIZE
	jc	.rc

	; save heap info
	mov	[mem.heap.start], eax
	mov	[mem.heap.size], HEAP_INIT_SIZE

	; create first heap block
	mov	[eax + HEAPBLOCK.sign], 'HB'
	mov	[eax + HEAPBLOCK.size], HEAP_INIT_SIZE - sizeof.HEAPBLOCK
	mov	[eax + HEAPBLOCK.prev], 0
	mov	[eax + HEAPBLOCK.last], 1
	mov	[eax + HEAPBLOCK.used], 0

	; initialized
	mov	[mem.alloc_count], 0
	mov	[mem.heap_corrupt], 0
	mov	[mem.initialized], 1

.rnc:	clc
.r:	ret
.rc:	stc
	ret
endp