;FASMLIB
;memory routines

;contains:                      @ = platform-specific
;@ proc  mem.init
;@ proc  mem.uninit

;@ proc  mem.alloc       size
;  proc  mem.alloc0      size
;@ proc  mem.free        blockptr
;@ proc  mem.realloc     blockptr, newsize
;  proc  mem.realloc0    blockptr, newsize
;@ proc  mem.size        blockptr

;  proc  mem.fill        dest, value, size
;  proc  mem.copy        dest, src, size
;  proc  mem.cmp         block1, block2, size
;  proc  mem.find        block, blocksize, pattern, patternsize
;  proc  mem.findb       block, blocksize, value


;include platform-specific part
match os,SYSTEM {
  include '_'#`os#'/mem.inc'
}

;procs
include 'mem/alloc0.inc'
include 'mem/realloc0.inc'
include 'mem/fill.inc'
include 'mem/copy.inc'
include 'mem/cmp.inc'
include 'mem/find.inc'
include 'mem/findb.inc'

; include heap manager if requested by OS-specific part
match =1, NEED_HEAP_MANAGER
{
  include 'heapmgr.inc'
}

;clear constants
restore NEED_HEAP_MANAGER