;; @name mstream.create
;; @desc
;;    Creates new {mstream:memory stream}.
;;    This is simple version. For more options see {mstream.extcreate}
;; @arg buffer
;;    Pointer to buffer where memory stream begins
;; @arg bufsz
;;    Size of buffer of memory stream.
;; @ret
;;    CF set on error, otherwise
;;    EAX = stream handle
;; @warn
;;    Don't forget to close stream with {stream.close}.
;; @warn
;;    Don't access buffer directly while it is used by stream.
;; @note
;;    If you try to write data behind end of buffer, write method
;;    returns ERR_BUFFER_FULL.
proc mstream.create buffer, bufsz
	libcall mstream.extcreate, 0, [buffer], [bufsz]
	ret
endp