;; @name str.inschar
;; @desc
;;    Inserts character to given position in another string.
;; @arg string
;;    Pointer to destination string, the one into which we insert.
;; @arg buflen
;;    Size of destination string buffer.
;; @arg char
;;    Character which we are inserting to string.
;;    Only low order byte of this dword is used, rest is ignored.
;; @arg pos
;;    Position in destination string where we are insrting.
;;    Position 0 corresponds to beginning of string, before first character.
;; @ret
;;    CF set on error, otherwise
;;    EAX = string.
;; @err ERR_OUT_OF_RANGE
;;    Position is outside of destination string, pos > strlen(dest).
;;    You are trying to insert behind end of string.
;; @err ERR_BUFFER_OVERFLOW
;;    Destination buffer is not big enough.
;;    Only first destlen bytes of resulting string were written.
;;    String in destination buffer is NOT zero terminated.
;; @err ERR_ZERO_SIZE
;;    destlen=0 or srclen=0
proc str.inschar string, buflen, char, pos

	;error if char=0
	cmp	[char], 0
	jne	@f
	mov	eax, ERR_ZERO_VALUE
	stc
	ret
@@:

	;lazy way, TODO
	;sorry.....
	libcall str.ins, [string], [buflen], addr char, 1, [pos]
	ret
endp
