;; @name stream.write.byte
;; @desc
;;    Writes one byte to stream.
;; @arg stream
;;    Handle of stream to which we write.
;; @arg value
;;    Byte value to write.
;;    Only low order byte of this dword is used, rest is ignored.
;; @ret
;;    CF set on error
;; @err ERR_INVALID_HANDLE
;;    Not a valid stream handle.
;; @err ERR_STREAM_NOT_WRITABLE
;;    Stream is not writeable.
;; @note This is just a helper procedure to call {stream write method}.
proc stream.write.byte stream, value
	lea	eax, [value]
	libcall stream.write, [stream], eax, 1
	ret
endp