;; @name text.fetch
;; @desc
;;    Reads specified ASCII string off the stream.
;;    If there is another string on stream, then nothing is read and ZF=1 is returned.
;;    This procedure should be only used with constant string argument.
;;    Use {text.fetch.str} for non-constant strings.
;; @arg stream
;;    Handle of stream to read from.
;; @arg string
;;    String to fetch from stream.
;; @ret
;;    CF set on error, otherwise
;;    ZF set if the string was fetched
;; @warn Only use this if string is guaranteed to be null terminated.
;;       Otherwise, use {text.fetch.str}.
;; @note For standard input, you can call {stdin.fetch} instead of passing {stdin} as argument.
;; @nodep text.fetch.str
proc text.fetch stream, string
	libcall text.fetch.str, [stream], [string], -1
	ret
endp
