;; @name text.read.hex_q
;; @desc
;;    Reads unsigned hexadecimal qword from stream.
;;    This is simple version, for more options see {text.extread.hex_q}.
;;    Reads hexadecimal digit characters ('0'-'9','a'-'z','A'-'Z') until it reaches non-digit, EOF,
;;    or until resulting value overflows.
;; @arg stream
;;    Handle of stream from which to read.
;; @ret
;;    CF set on error, otherwise
;;    EDX:EAX = readen qword
;; @err ERR_HANDLE_EOF
;;    EOF reached.
;; @err ERR_OUT_OF_RANGE
;;    value > FFFFFFFFFFFFFFFF.
;;    In this case all digit characters remain on stream.
;; @err ERR_NOT_HEXADECIMAL
;;    First character is not a hexadecimal digit.
;;    Character remains on stream.
;; @note Skips inital blank characters (space, tab, EOL).
;; @note Stream must have a read buffer.
;; @note If stream has static read buffer, it must be big enough to hold all digits
;;       of number.
proc text.read.hex_q stream
	libcall text.extread.hex_q, [stream], 0, 1, 0
	ret
endp