;; @name text.write.d_dec
;; @desc
;;    Writes unsigned dword (32 bit) to stream as ASCII decimal string.
;; @arg stream
;;    Handle of stream to write to.
;; @arg value
;;    Dword value to write.
;; @ret
;;    CF set on error
;; @note This is simpler version of procedure, for extended version see {text.extwrite.d_dec}.
;; @note For signed version, see {text.write.id_dec}.
proc text.write.d_dec stream, value
local	len	dd ?
local	buf	rb 11

	libcall extconv.d_dec, addr buf, 11, [value], 0, 0, addr len
	jc	.rc

	libcall stream.write, [stream], addr buf, [len]
	jc	.rc

.r:	ret
.rc:	stc
	jmp	.r
endp
