;; @name text.write.ib_dec
;; @desc
;;    Writes signed byte (8 bit) to stream as ASCII decimal string.
;;    This is simpler version of procedure, for extended version see {text.extwrite.b_dec}.
;;    For unsigned version, see {text.write.b_dec}.
;; @arg stream
;;    Handle of stream to write to.
;; @arg value
;;    Low order byte of this dword is value to write.
;; @ret
;;    CF set on error
proc text.write.ib_dec stream, value
local	len	dd ?
local	buf	rb 5

	libcall extconv.ib_dec, addr buf, 5, [value], 0, 0, 0, addr len
	jc	.rc

	libcall stream.write, [stream], addr buf, [len]
	jc	.rc

.r:	ret
.rc:	stc
	jmp	.r
endp
