;; @name text.write.id_dec
;; @desc
;;    Writes signed dword (32 bit) to stream as ASCII decimal string.
;;    This is simpler version of procedure, for extended version see {text.extwrite.id_dec}.
;;    For unsigned version, see {text.write.d_dec}.
;; @arg stream
;;    Handle of stream to write to.
;; @arg value
;;    Dword value to write.
;; @ret
;;    CF set on error
proc text.write.id_dec stream, value
local	len	dd ?
local	buf	rb 12

	libcall extconv.id_dec, addr buf, 12, [value], 0, 0, 0, addr len
	jc	.rc

	libcall stream.write, [stream], addr buf, [len]
	jc	.rc

.r:	ret
.rc:	stc
	jmp	.r
endp
