;; @name text.write.iq_dec
;; @desc
;;    Writes signed qword (64 bit) to stream as ASCII decimal string.
;;    This is simpler version of procedure, for extended version see {text.extwrite.iq_dec}.
;;    For unsigned version, see {text.write.q_dec}.
;; @arg stream
;;    Handle of stream to write to.
;; @arg valuelow
;;    Low order dword of value to write.
;; @arg valuehigh
;;    High order dword of value to write.
;; @ret
;;    CF set on error
proc text.write.iq_dec stream, valuelow, valuehigh
local	len	dd ?
local	buf	rb 22

	libcall extconv.iq_dec, addr buf, 22, [valuelow], [valuehigh], 0, 0, 0, addr len
	jc	.rc

	libcall stream.write, [stream], addr buf, [len]
	jc	.rc

.r:	ret
.rc:	stc
	jmp	.r
endp
