;; @name text.write.q_dec
;; @desc
;;    Writes unsigned qword (64 bit) to stream as ASCII decimal string.
;; @arg stream
;;    Handle of stream to write to.
;; @arg valuelow
;;    Low order dword of value to write.
;; @arg valuehigh
;;    High order dword of value to write.
;; @ret
;;    CF set on error
;; @note This is simpler version of procedure, for extended version see {text.extwrite.q_dec}.
;; @note For signed version, see {text.write.iq_dec}.
proc text.write.q_dec stream, valuelow, valuehigh
local	len	dd ?
local	buf	rb 21

	libcall extconv.q_dec, addr buf, 21, [valuelow], [valuehigh], 0, 0, addr len
	jc	.rc

	libcall stream.write, [stream], addr buf, [len]
	jc	.rc

.r:	ret
.rc:	stc
	jmp	.r
endp
