;; @name text.write.q_hex
;; @desc
;;    Writes unsigned qword (64 bit) to stream as ASCII hexadecimal string.
;; @arg stream
;;    Handle of stream to write to.
;; @arg valuelow
;;    Low order dword of value to write.
;; @arg valuehigh
;;    High order dword of value to write.
;; @ret
;;    CF set on error
;; @note This is simpler version of procedure, for extended version see {text.extwrite.q_hex}.
;; @note For signed version, see {text.write.iq_hex}.
proc text.write.q_hex stream, valuelow, valuehigh
local	len	dd ?
local	buf	rb 17

	libcall extconv.q_hex, addr buf, 17, [valuelow], [valuehigh], 0, 0, addr len
	jc	.rc

	libcall stream.write, [stream], addr buf, [len]
	jc	.rc

.r:	ret
.rc:	stc
	jmp	.r
endp