;; @name text.write.w_dec
;; @desc
;;    Writes unsigned word (16 bit) to stream as ASCII decimal string.
;; @arg stream
;;    Handle of stream to write to.
;; @arg value
;;    Low order word of this dword is value to write.
;; @ret
;;    CF set on error
;; @note This is simpler version of procedure, for extended version see {text.extwrite.w_dec}.
;; @note For signed version, see {text.write.iw_dec}.
proc text.write.w_dec stream, value
local	len	dd ?
local	buf	rb 6

	libcall extconv.w_dec, addr buf, 6, [value], 0, 0, addr len
	jc	.rc

	libcall stream.write, [stream], addr buf, [len]
	jc	.rc

.r:	ret
.rc:	stc
	jmp	.r
endp